using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using DCON_PC_DOTNET;

namespace Counter
{
	/// <summary>
	/// Form1 的摘要描述。
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textAddress;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.TextBox textTimeout;
		private System.Windows.Forms.TextBox textChecksum;
		private System.Windows.Forms.TextBox textSlot;
		private System.Windows.Forms.TextBox textBaudrate;
		private System.Windows.Forms.TextBox textComport;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Button Read_Counter;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Button Read_OverFlow;
		private System.Windows.Forms.Button Clear_Counter;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button Open_Com;
		private System.Windows.Forms.Button Close_Com;
		private System.Windows.Forms.TextBox textChannel;
		private System.Windows.Forms.TextBox textCounterValue;
		private System.Windows.Forms.TextBox textOverflowVal;
		/// <summary>
		/// 設計工具所需的變數。
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Windows Form 設計工具支援的必要項
			//
			InitializeComponent();

			//
			// TODO: 在 InitializeComponent 呼叫之後加入任何建構函式程式碼
			//
		}

		/// <summary>
		/// 清除任何使用中的資源。
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form 設計工具產生的程式碼
		/// <summary>
		/// 此為設計工具支援所必須的方法 - 請勿使用程式碼編輯器修改
		/// 這個方法的內容。
		/// </summary>
		private void InitializeComponent()
		{
			this.textAddress = new System.Windows.Forms.TextBox();
			this.label11 = new System.Windows.Forms.Label();
			this.textTimeout = new System.Windows.Forms.TextBox();
			this.textChecksum = new System.Windows.Forms.TextBox();
			this.textSlot = new System.Windows.Forms.TextBox();
			this.textBaudrate = new System.Windows.Forms.TextBox();
			this.textComport = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.textChannel = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.textCounterValue = new System.Windows.Forms.TextBox();
			this.label8 = new System.Windows.Forms.Label();
			this.Read_Counter = new System.Windows.Forms.Button();
			this.textOverflowVal = new System.Windows.Forms.TextBox();
			this.label9 = new System.Windows.Forms.Label();
			this.Read_OverFlow = new System.Windows.Forms.Button();
			this.Clear_Counter = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.Open_Com = new System.Windows.Forms.Button();
			this.Close_Com = new System.Windows.Forms.Button();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// textAddress
			// 
			this.textAddress.Location = new System.Drawing.Point(72, 64);
			this.textAddress.Name = "textAddress";
			this.textAddress.Size = new System.Drawing.Size(72, 22);
			this.textAddress.TabIndex = 63;
			this.textAddress.Text = "1";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(24, 64);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(48, 16);
			this.label11.TabIndex = 62;
			this.label11.Text = "Address";
			// 
			// textTimeout
			// 
			this.textTimeout.Location = new System.Drawing.Point(72, 200);
			this.textTimeout.Name = "textTimeout";
			this.textTimeout.Size = new System.Drawing.Size(72, 22);
			this.textTimeout.TabIndex = 59;
			this.textTimeout.Text = "100";
			// 
			// textChecksum
			// 
			this.textChecksum.Location = new System.Drawing.Point(72, 168);
			this.textChecksum.Name = "textChecksum";
			this.textChecksum.Size = new System.Drawing.Size(72, 22);
			this.textChecksum.TabIndex = 58;
			this.textChecksum.Text = "0";
			// 
			// textSlot
			// 
			this.textSlot.Location = new System.Drawing.Point(72, 136);
			this.textSlot.Name = "textSlot";
			this.textSlot.Size = new System.Drawing.Size(72, 22);
			this.textSlot.TabIndex = 57;
			this.textSlot.Text = "-1";
			// 
			// textBaudrate
			// 
			this.textBaudrate.Location = new System.Drawing.Point(72, 96);
			this.textBaudrate.Name = "textBaudrate";
			this.textBaudrate.Size = new System.Drawing.Size(72, 22);
			this.textBaudrate.TabIndex = 56;
			this.textBaudrate.Text = "9600";
			// 
			// textComport
			// 
			this.textComport.Location = new System.Drawing.Point(72, 32);
			this.textComport.Name = "textComport";
			this.textComport.Size = new System.Drawing.Size(72, 22);
			this.textComport.TabIndex = 55;
			this.textComport.Text = "1";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 208);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(48, 16);
			this.label5.TabIndex = 54;
			this.label5.Text = "Timeout";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 176);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 16);
			this.label4.TabIndex = 53;
			this.label4.Text = "CheckSum";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 144);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(24, 16);
			this.label3.TabIndex = 52;
			this.label3.Text = "Slot";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 104);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 16);
			this.label2.TabIndex = 51;
			this.label2.Text = "Baudrate";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 16);
			this.label1.TabIndex = 50;
			this.label1.Text = "ComPort";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.Open_Com);
			this.groupBox2.Controls.Add(this.Close_Com);
			this.groupBox2.Location = new System.Drawing.Point(8, 0);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(160, 296);
			this.groupBox2.TabIndex = 64;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Setting";
			// 
			// textChannel
			// 
			this.textChannel.Location = new System.Drawing.Point(240, 24);
			this.textChannel.Name = "textChannel";
			this.textChannel.Size = new System.Drawing.Size(56, 22);
			this.textChannel.TabIndex = 65;
			this.textChannel.Text = "";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(192, 24);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(48, 24);
			this.label7.TabIndex = 66;
			this.label7.Text = "Channel Number";
			// 
			// textCounterValue
			// 
			this.textCounterValue.Location = new System.Drawing.Point(240, 64);
			this.textCounterValue.Name = "textCounterValue";
			this.textCounterValue.Size = new System.Drawing.Size(56, 22);
			this.textCounterValue.TabIndex = 67;
			this.textCounterValue.Text = "";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(192, 64);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(48, 24);
			this.label8.TabIndex = 68;
			this.label8.Text = "Counter Value";
			// 
			// Read_Counter
			// 
			this.Read_Counter.Location = new System.Drawing.Point(192, 96);
			this.Read_Counter.Name = "Read_Counter";
			this.Read_Counter.Size = new System.Drawing.Size(104, 40);
			this.Read_Counter.TabIndex = 69;
			this.Read_Counter.Text = "Read Counter Value";
			this.Read_Counter.Click += new System.EventHandler(this.Read_Counter_Click);
			// 
			// textOverflowVal
			// 
			this.textOverflowVal.Location = new System.Drawing.Point(240, 152);
			this.textOverflowVal.Name = "textOverflowVal";
			this.textOverflowVal.Size = new System.Drawing.Size(56, 22);
			this.textOverflowVal.TabIndex = 70;
			this.textOverflowVal.Text = "";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(184, 152);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(56, 24);
			this.label9.TabIndex = 71;
			this.label9.Text = "Overflow Value";
			// 
			// Read_OverFlow
			// 
			this.Read_OverFlow.Location = new System.Drawing.Point(192, 192);
			this.Read_OverFlow.Name = "Read_OverFlow";
			this.Read_OverFlow.Size = new System.Drawing.Size(104, 40);
			this.Read_OverFlow.TabIndex = 72;
			this.Read_OverFlow.Text = "Read Overflow";
			this.Read_OverFlow.Click += new System.EventHandler(this.Read_OverFlow_Click);
			// 
			// Clear_Counter
			// 
			this.Clear_Counter.Location = new System.Drawing.Point(192, 240);
			this.Clear_Counter.Name = "Clear_Counter";
			this.Clear_Counter.Size = new System.Drawing.Size(104, 40);
			this.Clear_Counter.TabIndex = 73;
			this.Clear_Counter.Text = "Clear Counter";
			this.Clear_Counter.Click += new System.EventHandler(this.Clear_Counter_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Location = new System.Drawing.Point(176, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(136, 296);
			this.groupBox1.TabIndex = 74;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Counter";
			// 
			// Open_Com
			// 
			this.Open_Com.Location = new System.Drawing.Point(6, 240);
			this.Open_Com.Name = "Open_Com";
			this.Open_Com.Size = new System.Drawing.Size(72, 32);
			this.Open_Com.TabIndex = 75;
			this.Open_Com.Text = "Open Com";
			this.Open_Com.Click += new System.EventHandler(this.Open_Com_Click);
			// 
			// Close_Com
			// 
			this.Close_Com.Location = new System.Drawing.Point(82, 240);
			this.Close_Com.Name = "Close_Com";
			this.Close_Com.Size = new System.Drawing.Size(72, 32);
			this.Close_Com.TabIndex = 76;
			this.Close_Com.Text = "Close Com";
			this.Close_Com.Click += new System.EventHandler(this.Close_Com_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 15);
			this.ClientSize = new System.Drawing.Size(320, 309);
			this.Controls.Add(this.Clear_Counter);
			this.Controls.Add(this.Read_OverFlow);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.textOverflowVal);
			this.Controls.Add(this.Read_Counter);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.textCounterValue);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.textChannel);
			this.Controls.Add(this.textAddress);
			this.Controls.Add(this.label11);
			this.Controls.Add(this.textTimeout);
			this.Controls.Add(this.textChecksum);
			this.Controls.Add(this.textSlot);
			this.Controls.Add(this.textBaudrate);
			this.Controls.Add(this.textComport);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// 應用程式的主進入點。
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		short iSlot,iTimeout,iAddress,bChecksum;
		byte iComport;
		uint iBaudrate;

		private void Open_Com_Click(object sender, System.EventArgs e)
		{
			iComport=Convert.ToByte(textComport.Text);
			iAddress = Convert.ToInt16(textAddress.Text);
			iBaudrate=Convert.ToUInt32(textBaudrate.Text);
			iSlot=Convert.ToInt16(textSlot.Text);
			bChecksum=Convert.ToInt16(textChecksum.Text);
			iTimeout=Convert.ToInt16(textTimeout.Text);
			
			DCON.UART.Open_Com(iComport,iBaudrate,8,0,1);
		}

		private void Close_Com_Click(object sender, System.EventArgs e)
		{
			DCON.UART.Close_Com(iComport);
		}

		private void Read_Counter_Click(object sender, System.EventArgs e)
		{
			uint CounterValue;
			short iRet;
			iRet=DCON.IO_Function.Read_Counter(iComport,iAddress,iSlot,Convert.ToInt16(textChannel.Text),bChecksum,iTimeout,out CounterValue);
			
			if(Convert.ToBoolean( iRet))
				MessageBox.Show("ErrorCode " + Convert.ToString(iRet));
			else			
				textCounterValue.Text=Convert.ToString(CounterValue);
		}

		private void Read_OverFlow_Click(object sender, System.EventArgs e)
		{
			short Overflow;
			short iRet;

			iRet=DCON.IO_Function.Read_Counter_Overflow(iComport,iAddress,iSlot,Convert.ToInt16(textChannel.Text),bChecksum,iTimeout,out Overflow);
			
			if(Convert.ToBoolean( iRet))
				MessageBox.Show("ErrorCode " + Convert.ToString(iRet));
			else
				textOverflowVal.Text=Convert.ToString(Overflow);
		}

		private void Clear_Counter_Click(object sender, System.EventArgs e)
		{
			DCON.IO_Function.Clear_Counter(iComport,iAddress,iSlot,Convert.ToInt16(textChannel.Text),bChecksum,iTimeout);
		}
	}
}
